import { Meta, Story, Canvas, Description } from '@storybook/addon-docs/blocks';
import readme from './readme.md';
import { InfoCardVariation } from './info-card-variation.enum';
import { InfoCardType } from './info-card-type.enum';
import { InfoCardHeadingLevel } from './info-card-heading-level.enum';

<Meta title="Info Card/digi-info-card" />

<!-- Description pulled from auto generated Stencil docs -->

<Description markdown={readme} />

## Standard

This is the standard info card. You need to provide a heading and a heading level. Typescript users should import and use `InfoCardHeadingLevel` to set heading type (h1-h6).

<Canvas>
  <Story name="Standard">
    /* html */
    {`
      <digi-info-card af-heading="I am an info card" af-heading-level="${InfoCardHeadingLevel.H3}">
        <p>
          These are just words to illustrate how it looks like with text inside. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse commodo egestas elit in
          consequat. Proin in ex consectetur, laoreet augue sit amet, malesuada tellus.
        </p>
      </digi-info-card>
    `}
  </Story>
</Canvas>

## Variations

The component exists in a few different variations. Typescript users should import and use `InfoCardVariation` to set variation.

### Primary

Primary info cards have a green background. This is the default behavior, so it is the same as the standard version.

<Canvas>
  <Story name="Variation - Primary">
    /* html */
    {`
      <digi-info-card
        af-heading="I am a primary info card"
        af-heading-level="${InfoCardHeadingLevel.H3}"
        af-variation="${InfoCardVariation.PRIMARY}"
      >
        <p>These are just words to illustrate how it looks like with text inside. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse commodo egestas elit in consequat. Proin in ex consectetur, laoreet augue sit amet, malesuada tellus.</p>
      </digi-info-card>
    `}
  </Story>
</Canvas>

### Secondary

Secondary info cards have a gray background. This is the default behavior, so it is the same as the standard version.

<Canvas>
  <Story name="Variation - Secondary">
    /* html */
    {`
      <digi-info-card
        af-heading="I am a secondary info card"
        af-heading-level="${InfoCardHeadingLevel.H3}"
        af-variation="${InfoCardVariation.SECONDARY}"
      >
        <p>These are just words to illustrate how it looks like with text inside. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse commodo egestas elit in consequat. Proin in ex consectetur, laoreet augue sit amet, malesuada tellus.</p>
      </digi-info-card>
    `}
  </Story>
</Canvas>

## With Link

Info cards can have an optional link (though some types require it. See below for when and where).

<Canvas>
  <Story name="With Link" parameters={{
    actions: {
      handles: ['afOnClickLink']
    }
  }}>
    /* html */
    {`
      <digi-info-card
        af-heading="I am an info card with an optional link"
        af-heading-level="${InfoCardHeadingLevel.H3}"
        af-link-text="I am an optional link"
        af-link-href="#"
      >
          <p>These are just words to illustrate how it looks like with text inside. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse commodo egestas elit in consequat. Proin in ex consectetur, laoreet augue sit amet, malesuada tellus.</p>
      </digi-info-card>
    `}
  </Story>
</Canvas>

## Types

There are a few different types of info-cards. These have different behaviors and different usages. Please see the [usage guidelines](https://digi.arbetsformedlingen.se/komponenter/infokort-infocard.html).  Typescript users should import and use `InfoCardType` to set type.

### Tip

Type "tip" is the default type, so it look just like the standard info card. This is what you get if `af-type` is not set.

<Canvas>
  <Story name="Type - Tip">
    /* html */
    {`
      <digi-info-card
        af-heading="I am an info card with type tip"
        af-heading-level="${InfoCardHeadingLevel.H3}"
        af-type="${InfoCardType.TIP}"
      >
        <p>These are just words to illustrate how it looks like with text inside. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse commodo egestas elit in consequat. Proin in ex consectetur, laoreet augue sit amet, malesuada tellus.</p>
      </digi-info-card>
    `}
  </Story>
</Canvas>

### Info

Type "info" communicates information, and can have an optional link.

<Canvas>
  <Story name="Type - Info" parameters={{
    actions: {
      handles: ['afOnClickLink']
    }
  }}>
    /* html */
    {`
      <digi-info-card
        af-heading="I am an info card with type info"
        af-heading-level="${InfoCardHeadingLevel.H3}"
        af-type="${InfoCardType.INFO}"
        af-link-text="I am an optional link"
        af-link-href="#"
      >
        <p>These are just words to illustrate how it looks like with text inside. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse commodo egestas elit in consequat. Proin in ex consectetur, laoreet augue sit amet, malesuada tellus.</p>
      </digi-info-card>
    `}
  </Story>
</Canvas>

### Single

Type "single" should be used at the end of content, to guide you to the next step. This must always have a link!

<Canvas>
  <Story name="Type - Single" parameters={{
    actions: {
      handles: ['afOnClickLink']
    }
  }}>
    /* html */
    {`
      <digi-info-card
        af-heading="I am an info card with type single"
        af-heading-level="${InfoCardHeadingLevel.H3}"
        af-type="${InfoCardType.SINGLE}"
        af-link-text="I am a required link"
        af-link-href="#"
      >
        <p>These are just words to illustrate how it looks like with text inside. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse commodo egestas elit in consequat. Proin in ex consectetur, laoreet augue sit amet, malesuada tellus.</p>
      </digi-info-card>
    `}
  </Story>
</Canvas>

### Multi

Type "multi" communicates information, and must have a link! Multi cards should always be placed inside `<digi-info-card-multi-container>`

<Canvas>
  <Story name="Type - Multi" parameters={{
    actions: {
      handles: ['afOnClickLink']
    }
  }}>
    /* html */
    {`
      <digi-info-card
        af-heading="I am an info card with type multi"
        af-heading-level="${InfoCardHeadingLevel.H3}"
        af-type="${InfoCardType.MULTI}"
        af-link-text="I am a required link"
        af-link-href="#"
      >
        <p>I should always be used inside of 'digi-info-card-multi-container'. These are just words to illustrate how it looks like with text inside.</p>
      </digi-info-card>
    `}
  </Story>
</Canvas>
